local ADDON = ...

local GMAUTOPSY_OUTNAM = {"SELF", "LDB", "GROUP", "GUILD", "OFFICER"}
local GMAUTOPSY_REPORT = {}

GMAUTOPSY_CFG = {
		MAXREP = 35,    -- max num of recent 
		ENABLED = true,
		CHANNEL = 1,
}

local prgname = "|cffffd200gmAutopsy|r"
local string_format = string.format

local fontName, fontHeight, fontFlags = GameFontNormal:GetFont()
local BUTTON_HEIGHT = fontHeight + 4
local BUTTON_SPACING = 0
local MENU_BUFFER = 10
local MENU_SPACING = 1
local MENU_WIDTH_EMPTY = 250
local MENU_WIDTH = 600

local function color(destName)
	if not UnitExists(destName) then return string_format("\124cffff0000%s\124r", destName) end
	local _, class = UnitClass(destName)
	local color = _G["RAID_CLASS_COLORS"][class]
	return string_format("\124cff%02x%02x%02x%s\124r", color.r*255, color.g*255, color.b*255, destName)
end

local number = function(v)
	if v <= 9999 then return v	
	elseif v >= 1000000 then return format("%.1fM", v/1000000)
	elseif v >= 10000 then return format("%.1fK", v/1000)
	end
end

local function unescape(String)
	local Result = tostring(String)
	Result = gsub(Result, "|H.-|h(.-)|h", "%1") -- Remove links.
	Result = gsub(Result, "%[", "") -- Remove links.
	Result = gsub(Result, "%]", "") -- Remove links.
	-- Result = gsub(Result, "%-[^|]+", "")
	return Result
end

local function unescape2(String)
	local Result = tostring(String)
	Result = gsub(Result, "%[", "") -- Remove links.
	Result = gsub(Result, "%]", "") -- Remove links.
	-- Result = gsub(Result, "%-[^|]+", "")
	return Result
end


-- upvalues to be used perhaps in the future.
local string_format = string.format
local string_find = string.find
local string_sub = string.sub

local function color(String)
	if not UnitExists(String) then return string.format("\124cffff0000%s\124r", String) end
	local _, class = UnitClass(String)
	local color = _G["RAID_CLASS_COLORS"][class]
	return string.format("\124cff%02x%02x%02x%s\124r", color.r*255, color.g*255, color.b*255, String)
end

local dataobj = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject(ADDON, {
	type = "data source",
	icon = "Interface\\Addons\\"..ADDON.."\\icon.png",
	text = ADDON,
})

local Menu = CreateFrame('Frame', nil, UIParent)
Menu:SetFrameStrata('TOOLTIP')
Menu:SetClampedToScreen(true)
Menu:SetBackdrop({
	bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
	edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
	tile = true, tileSize = 32, edgeSize = 16,
	insets = { left = 3, right = 3, top = 3, bottom = 3 }
})
Menu:Hide()


local function demoToolTip()

	local numButtons = GMAUTOPSY_CFG["MAXREP"]
	for index=1,GMAUTOPSY_CFG["MAXREP"] do

		local sources = {"Udvud il macellaio", "Brown Marmot", "Wolf", "Black Mamba", "Calamir", "Umongris", "Drugon il Sangue Gelido"}
		local damages = {"Melee", 30455, 219602, 219349, 216043, 213590, 223689}
		local damage = damages[math.random(7)]
		
		if damage == "Melee" then 
		
			GMAUTOPSY_REPORT[#GMAUTOPSY_REPORT+1] = {
				timestamp 	= date("%H:%M:%S",timestamp),
				sourceName 	= sources[math.random(7)],
				destName 	= UnitName("player"),
				spell 		= "Melee",
				damage		= number(math.random(500000,2000000)),
				overkill	= number(math.random(500000))
			}

		else

			GMAUTOPSY_REPORT[#GMAUTOPSY_REPORT+1] = {
				timestamp 	= date("%H:%M:%S",timestamp),
				sourceName 	= sources[math.random(7)],
				destName 	= UnitName("player"),
				spell 		= GetSpellLink(damage),
				damage		= number(math.random(500000,2000000)),
				overkill	= number(math.random(500000))
			}


		end
		

		local string = 	string_format("%s |cFFFF0000%s|r - %s - %s - %s - %s ]", 
						GMAUTOPSY_REPORT[index]["timestamp"],
						GMAUTOPSY_REPORT[index]["sourceName"],
						color(GMAUTOPSY_REPORT[index]["destName"]),
						unescape2(GMAUTOPSY_REPORT[index]["spell"]),
						GMAUTOPSY_REPORT[index]["damage"],
						GMAUTOPSY_REPORT[index]["overkill"]) 
		
		Menu[index]:SetText("")
		Menu[index]:SetText(string)
		Menu[index]:Show()

		Menu:SetSize(MENU_WIDTH, (MENU_BUFFER * 5) + (fontHeight * 3) + MENU_SPACING + ((BUTTON_HEIGHT + BUTTON_SPACING) * numButtons - BUTTON_SPACING))
		
	end
end

local function initMenu()

		GMAUTOPSY_REPORT = {}
		
		for index = 1, GMAUTOPSY_CFG["MAXREP"] do
			Menu[index]:SetText("")
			Menu[index]:Hide()
		end
		
		Menu:SetSize(MENU_WIDTH_EMPTY, (MENU_BUFFER * 5) + (fontHeight * 3) + MENU_SPACING + ((BUTTON_HEIGHT + BUTTON_SPACING) - BUTTON_SPACING))
end

local function Menu_OnLeave()
	local focus = GetMouseFocus() or WorldFrame
	if focus ~= Menu and focus:GetParent() ~= Menu then
		Menu:Hide()
	end
end
Menu:SetScript('OnLeave', Menu_OnLeave)

local header_desc = Menu:CreateFontString()
header_desc:SetPoint("TOPLEFT", Menu, "TOPLEFT", MENU_BUFFER, -MENU_BUFFER)
header_desc:SetFont(fontName, fontHeight)
header_desc:SetTextColor(1, 1, 1, 1)
header_desc:SetText(header_desc_string)

local mclick_desc = Menu:CreateFontString()
mclick_desc:SetPoint("BOTTOMLEFT", Menu, "BOTTOMLEFT", MENU_BUFFER, MENU_BUFFER)
mclick_desc:SetFont(fontName, fontHeight)
mclick_desc:SetTextColor(0, 1, 0, 1)
mclick_desc:SetText("Middle-Click")

local mclick_value = Menu:CreateFontString()
mclick_value:SetPoint("BOTTOMRIGHT", Menu, "BOTTOMRIGHT", -MENU_BUFFER, MENU_BUFFER)
mclick_value:SetFont(fontName, fontHeight)
mclick_value:SetTextColor(1, 0.8, 0, 1)
mclick_value:SetText("Reset")

local rclick_desc = Menu:CreateFontString()
rclick_desc:SetPoint("BOTTOMLEFT", mclick_desc, "TOPLEFT", 0, MENU_SPACING)
rclick_desc:SetFont(fontName, fontHeight)
rclick_desc:SetTextColor(0, 1, 0, 1)
rclick_desc:SetText("Right-Click")

local rclick_value = Menu:CreateFontString()
rclick_value:SetPoint("BOTTOMRIGHT", mclick_value, "TOPRIGHT", 0, MENU_SPACING)
rclick_value:SetFont(fontName, fontHeight)
rclick_value:SetTextColor(1, 0.8, 0, 1)
rclick_value:SetText("Whisper Player")

local lclick_desc = Menu:CreateFontString()
lclick_desc:SetPoint("BOTTOMLEFT", rclick_desc, "TOPLEFT", 0, MENU_SPACING)
lclick_desc:SetFont(fontName, fontHeight)
lclick_desc:SetTextColor(0, 1, 0, 1)
lclick_desc:SetText("Left-Click")

local lclick_value = Menu:CreateFontString()
lclick_value:SetPoint("BOTTOMRIGHT", rclick_value, "TOPRIGHT", 0, MENU_SPACING)
lclick_value:SetFont(fontName, fontHeight)
lclick_value:SetTextColor(1, 0.8, 0, 1)
lclick_value:SetText("Show Item Tooltip")


local function UpdateLDB()

	if (GMAUTOPSY_CFG["ENABLED"] == false) then
		dataobj.icon = "Interface\\Addons\\"..ADDON.."\\icon-off.tga"
		dataobj.text = string_format("|cffff0000%s|r", "OFF")
		Menu:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	else 
		dataobj.icon = "Interface\\Addons\\"..ADDON.."\\icon.tga"
		dataobj.text = string_format("|cff00ff00%s|r", GMAUTOPSY_OUTNAM[GMAUTOPSY_CFG["CHANNEL"]])
		Menu:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	end
end

function dataobj.OnClick(self, button)
	
		if (button == "LeftButton" and GMAUTOPSY_CFG["ENABLED"] == true) then
		
			Menu:SetShown(not Menu:IsShown())
			
			if (GMAUTOPSY_CFG["CHANNEL"] == 5) then 					
				GMAUTOPSY_CFG["CHANNEL"] = 1
			else
				GMAUTOPSY_CFG["CHANNEL"] = GMAUTOPSY_CFG["CHANNEL"] + 1
			end		
			
		elseif button == "RightButton" then
	
			GMAUTOPSY_CFG["ENABLED"] = not GMAUTOPSY_CFG["ENABLED"]

		elseif button == "MiddleButton" then
		
			initMenu()
			
			if IsAltKeyDown() then 

				demoToolTip()
		
			end 		
		end
	
	UpdateLDB()	
end

function dataobj.OnEnter(self)

	if not Menu:IsShown() then
		local _, selfCenter = self:GetCenter()
		local _, uiCenter = UIParent:GetCenter()
		Menu:ClearAllPoints()
		if selfCenter >= uiCenter then
			Menu:SetPoint('TOP', self, 'BOTTOM')
		else
			Menu:SetPoint('BOTTOM', self, 'TOP')
		end
		Menu:Show()
	end
end

function dataobj.OnLeave(self)

	Menu_OnLeave()

end


local function Button_OnClick(self, button, down)

	if button == "RightButton" then

		SendChatMessage("You are killed by " .. GMAUTOPSY_REPORT[self.index]["spell"] .. " with " .. GMAUTOPSY_REPORT[self.index]["damage"] .. " overkill " .. GMAUTOPSY_REPORT[self.index]["overkill"] , "WHISPER", nil, GMAUTOPSY_REPORT[self.index]["destName"])
		
		
	elseif button == "LeftButton" then

		if GMAUTOPSY_REPORT[self.index]["spell"] == "Melee" then return end
		
		ShowUIPanel(ItemRefTooltip)
		
		if not ItemRefTooltip:IsShown() then
			
			ItemRefTooltip:SetOwner(UIParent, "ANCHOR_PRESERVE")

		end
			
		ItemRefTooltip:SetHyperlink(GMAUTOPSY_REPORT[self.index]["spell"])		
		return

	elseif button == "MiddleButton" then
	


	end

	Menu:Hide()
	
end


Menu:RegisterEvent("ZONE_CHANGED_NEW_AREA")
Menu:RegisterEvent("PLAYER_ENTERING_WORLD")
Menu:RegisterEvent('PLAYER_LOGIN')
Menu:SetScript("OnEvent", function(self, event, ...)
	
	
	if event == "PLAYER_LOGIN" then	

		Menu:UnregisterEvent(event)
		
		for index = 1, GMAUTOPSY_CFG["MAXREP"] do
		
			local button = CreateFrame("Button", nil, Menu)
			
			if index ~= 1 then
				button:SetPoint("TOPLEFT", Menu[index - 1], "BOTTOMLEFT", 0, -BUTTON_SPACING)
			else
				button:SetPoint("TOPLEFT", header_desc, "BOTTOMLEFT", 0, -MENU_BUFFER)
			end
			
			button:SetPoint("RIGHT", -MENU_BUFFER, 0)
			button:SetHeight(BUTTON_HEIGHT)
			button:SetNormalFontObject("GameFontNormal")
			button:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight")
			button.index = index
			button:RegisterForClicks("AnyDown")
			button:SetScript("OnClick", Button_OnClick)
			button:SetScript("OnLeave", Menu_OnLeave)

			local text = button:CreateFontString(ADDON .. "btn_font", nil, "GameFontNormal")
			text:SetAllPoints()
			text:SetJustifyH("LEFT")
			text:SetJustifyV("MIDDLE")
			text:SetTextColor(1, 1, 1, 1)
			
			button:SetFontString(text)
			Menu[index] = button
		end		
		
		initMenu()
		
		
	elseif event == "ZONE_CHANGED_NEW_AREA" or event == "PLAYER_ENTERING_WORLD" then	
	
		UpdateLDB()
		
	elseif event == "COMBAT_LOG_EVENT_UNFILTERED" then
	
		local timestamp, clevent, _, _, sourceName, _, _, destGUID, destName, _, _, prefixParam1, prefixParam2, _, suffixParam1, suffixParam2 = CombatLogGetCurrentEventInfo()
		local playerGUID
		local damagetype
		local autopsy_msg = nil
 		
		-- proceed with CLEU handling
		if not playerGUID then 
			playerGUID = UnitGUID("player") 
		end
		
		if (destGUID == playerGUID or (destName and UnitClass(destName))) and destGUID:sub(1,3) ~=	"Pet" then

		-- if destGUID:sub(1,3) ==	"Pet" then  end

		-- if destGUID:sub(1,3) ~=	"Pet" then print ("DEBUG: PET") end
			-- print("DEBUG:" .. destGUID)
		
			sourceName = sourceName or "Someone"
			
			if clevent == "SWING_DAMAGE" then
			
				if prefixParam2 > 0 then 
					autopsy_msg = string_format("gmAutopsy: %s killed %s with %s Melee overkill %s", sourceName, destName, prefixParam1, prefixParam2)
				
					GMAUTOPSY_REPORT[#GMAUTOPSY_REPORT+1] = {
						timestamp 	= date("%H:%M",timestamp),
						sourceName 	= sourceName,
						destName 	= destName,
						spell 		= "Melee",
						damage		= number(prefixParam1),
						overkill	= number(prefixParam2)
					}					
				end
			
			elseif clevent == "SPELL_DAMAGE" or clevent == "SPELL_PERIODIC_DAMAGE" or clevent == "RANGE_DAMAGE" then
			
				if suffixParam2 > 0 then 
					autopsy_msg = string_format("gmAutopsy: %s killed %s with %s damage of %s overkill %s", sourceName, color(destName), suffixParam1, GetSpellLink(prefixParam1), suffixParam2)

					GMAUTOPSY_REPORT[#GMAUTOPSY_REPORT+1] = {
						timestamp 	= date("%H:%M",timestamp),
						sourceName 	= sourceName,
						destName 	= destName,
						spell 		= GetSpellLink(prefixParam1),
						damage		= number(suffixParam1),
						overkill	= number(suffixParam2)
					}					
				end				
			end

			
			if #GMAUTOPSY_REPORT >= GMAUTOPSY_CFG["MAXREP"] then table.remove(GMAUTOPSY_REPORT, 1) end
			
			if #GMAUTOPSY_REPORT > 0 then 


				local numButtons = #GMAUTOPSY_REPORT
				for index = 1, numButtons do				
				
					local string = 	string_format("%s |cFFFF0000%s|r - %s - %s [ %s | %s ]", 
									GMAUTOPSY_REPORT[index]["timestamp"],
									GMAUTOPSY_REPORT[index]["sourceName"],
									color(GMAUTOPSY_REPORT[index]["destName"]),
									GMAUTOPSY_REPORT[index]["spell"],
									GMAUTOPSY_REPORT[index]["damage"],
									GMAUTOPSY_REPORT[index]["overkill"]) 
				
					Menu[index]:SetText("")
					Menu[index]:SetText(string)
					Menu[index]:Show()

				end 
				Menu:SetSize(MENU_WIDTH, (MENU_BUFFER * 5) + (fontHeight * 3) + MENU_SPACING + ((BUTTON_HEIGHT + BUTTON_SPACING) * numButtons - BUTTON_SPACING))
			
			end			
 			
			if autopsy_msg then 
			
				local autopsy_chn = GMAUTOPSY_OUTNAM[GMAUTOPSY_CFG["CHANNEL"]]

				if 	GMAUTOPSY_CFG["CHANNEL"] == 1 or autopsy_chn == "SELF" then 
					print(autopsy_msg)	
				end 
				
				-- find the right GROUP, thanks to Dridzt code in the posts: http://www.wowinterface.com/forums/showthread.php?t=48320
				if GMAUTOPSY_CFG["CHANNEL"] == 3 then				
					if IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
					  autopsy_chn = "INSTANCE_CHAT"
					elseif IsInRaid() then
					  autopsy_chn = "RAID"
					elseif IsInGroup() then
					  autopsy_chn = "PARTY"
					else
					  autopsy_chn = "SELF"
					end
				end
								
				if (GMAUTOPSY_CFG["CHANNEL"] > 2 )then 
					SendChatMessage(autopsy_msg, autopsy_chn)
				end 
			end			
		end
	end	
end)


SLASH_GMAUTOPSY1 = "/gmautopsy"
SlashCmdList["GMAUTOPSY"] = function(args) 
	local param=SecureCmdOptionParse(args)
	param=param:lower()
	
	if param=="" then
		print(ADDON .. ":")
		print("/gmautopsy  - This help")
		print("/gmautopsy show - Show")
		return
		
	elseif param == "show" then 
	
		if not Menu:IsShown() then
			Menu:ClearAllPoints()
			Menu:SetPoint('CENTER',0,0)
			Menu:Show()
		end	
	end
end